import sqlite3
from wsgiref.simple_server import make_server


#
# SQL
#
def create_html(dotaz):

    # připojení k SQLite-databázi
    connection = sqlite3.connect('../monitory.sqlite')
    cursor = connection.cursor()

    # zpracování dat
    cursor.execute(f'''
        SELECT * FROM monitory
            WHERE brand LIKE "%{dotaz}%";
    ''')

    # HTML-data odpovědi
    body = ''

    # styly
    body += '''
    <style>
        tr:nth-child(2n) {}
        tr:nth-child(2n+1) { background-color: lightblue; }
    </style>
    '''
    # tabulka
    body += '<table border>\n'
    # hlavičkový řádek
    body += '<tr style="background-color: yellow;">\n'
    body += '''
        <th>brand</th>
        <th>model</th>
        <th>size</th>
        <th>hres</th>
        <th>vres</th>
        <th>aspect</th>
        <th>inputs</th>
        <th>support</th>
        <th>year</th>
        <th>comments</th>
    '''
    body += '</tr>\n'
    # data
    for řádka in cursor:
        _, brand, model, size, hres, vres, aspect, inputs, support, year, comments = řádka
        body += f'''
            <tr>
                <td>{brand}</td>
                <td>{model}</td>
                <td>{size}</td>
                <td>{hres}</td>
                <td>{vres}</td>
                <td>{aspect}</td>
                <td>{inputs}</td>
                <td>{support}</td>
                <td>{year}</td>
                <td>{comments}</td>
            </tr>
        '''
    # konec
    body += '</table>\n'

    # uzavření spojení
    cursor.close()
    connection.close()
    
    # vrácení vyrobené HTML-stránky
    return body



#
# WSGI-klient
#
def application(environ, start_response):
    dotaz = environ['QUERY_STRING']
    html = create_html(dotaz)
    if html is None:
        html = ''
    data = bytes(html, encoding='utf-8')
    response_headers = [
        ("Content-type", "text/html; charset=UTF-8"),
        ("Content-length", str(len(data)) ),
    ]
    start_response("200 OK", response_headers)
    return (data,)
 
# WSGI-server (spuštěn pro jednu odpověď)
server = make_server('localhost', 8080, application)
server.handle_request()
